package mqtt.proxy;


import anywheresoftware.b4a.BA;

public class main extends Object{
public static main mostCurrent = new main();

public static BA ba;
static {
		ba = new  anywheresoftware.b4a.StandardBA("mqtt.proxy", "mqtt.proxy.main", null);
		ba.loadHtSubs(main.class);
        if (ba.getClass().getName().endsWith("ShellBA")) {
			
			ba.raiseEvent2(null, true, "SHELL", false);
			ba.raiseEvent2(null, true, "CREATE", true, "mqtt.proxy.main", ba);
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}

 
    public static void main(String[] args) throws Exception{
        try {
            anywheresoftware.b4a.keywords.Common.LogDebug("Program started.");
            initializeProcessGlobals();
            ba.raiseEvent(null, "appstart", (Object)args);
        } catch (Throwable t) {
			BA.printException(t, true);
		
        } finally {
            anywheresoftware.b4a.keywords.Common.LogDebug("Program terminated (StartMessageLoop was not called).");
        }
    }
public static anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.randomaccessfile.AsyncStreams _ast1 = null;
public static anywheresoftware.b4a.objects.SocketWrapper _client = null;
public static String _destip = "";
public static int _destport = 0;
public static boolean _tconnected = false;
public static anywheresoftware.b4a.randomaccessfile.AsyncStreams _ast2 = null;
public static anywheresoftware.b4a.objects.SocketWrapper.ServerSocketWrapper _server = null;
public static int _lport = 0;
public static anywheresoftware.b4a.objects.SocketWrapper _lclient = null;
public static boolean _lconnected = false;
public static anywheresoftware.b4j.objects.MqttAsyncClientWrapper _mqtt = null;
public static String _mqtt_topic = "";
public static String _mqtt_user = "";
public static String _mqtt_password = "";
public static String _mqtt_server = "";
public static String _mqtt_clientid = "";
public static int _mqtt_qos = 0;
public static boolean _working = false;
public static String _pmode = "";
public static String  _appstart(String[] _args) throws Exception{
 //BA.debugLineNum = 44;BA.debugLine="Sub AppStart (Args() As String)";
 //BA.debugLineNum = 45;BA.debugLine="Log(\"TCP Proxy Server via MQTT Tunnel V1.0\")";
anywheresoftware.b4a.keywords.Common.LogImpl("565537","TCP Proxy Server via MQTT Tunnel V1.0",0);
 //BA.debugLineNum = 46;BA.debugLine="ReadCFGFile";
_readcfgfile();
 //BA.debugLineNum = 47;BA.debugLine="working=True";
_working = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 48;BA.debugLine="Log(\"Program Mode: \" & pmode)";
anywheresoftware.b4a.keywords.Common.LogImpl("565540","Program Mode: "+_pmode,0);
 //BA.debugLineNum = 50;BA.debugLine="mqtt_clientID = \"MQTTPROXY\" & Rnd(0, 999999999) &";
_mqtt_clientid = "MQTTPROXY"+BA.NumberToString(anywheresoftware.b4a.keywords.Common.Rnd((int) (0),(int) (999999999)))+BA.NumberToString(anywheresoftware.b4a.keywords.Common.DateTime.getNow());
 //BA.debugLineNum = 51;BA.debugLine="ConnectToMQTTServer";
_connecttomqttserver();
 //BA.debugLineNum = 53;BA.debugLine="If pmode = \"local\" Then";
if ((_pmode).equals("local")) { 
 //BA.debugLineNum = 54;BA.debugLine="server.Initialize(Lport, \"server\")";
_server.Initialize(ba,_lport,"server");
 //BA.debugLineNum = 55;BA.debugLine="ListenForConnections";
_listenforconnections();
 };
 //BA.debugLineNum = 58;BA.debugLine="StartMessageLoop";
anywheresoftware.b4a.keywords.Common.StartMessageLoop(ba);
 //BA.debugLineNum = 60;BA.debugLine="End Sub";
return "";
}
public static String  _ast1_error() throws Exception{
 //BA.debugLineNum = 158;BA.debugLine="Sub AST1_Error";
 //BA.debugLineNum = 159;BA.debugLine="Tconnected=False";
_tconnected = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 160;BA.debugLine="Log(destIP & \" - AST1-TCP Error\")  						'This ev";
anywheresoftware.b4a.keywords.Common.LogImpl("5655362",_destip+" - AST1-TCP Error",0);
 //BA.debugLineNum = 161;BA.debugLine="End Sub";
return "";
}
public static String  _ast1_newdata(byte[] _buffer) throws Exception{
 //BA.debugLineNum = 170;BA.debugLine="Private Sub AST1_NewData (Buffer() As Byte)";
 //BA.debugLineNum = 173;BA.debugLine="mqtt.Publish2(mqtt_topic & \"fromclient\",Buffer,m";
_mqtt.Publish2(_mqtt_topic+"fromclient",_buffer,_mqtt_qos,anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 174;BA.debugLine="End Sub";
return "";
}
public static String  _ast1_terminated() throws Exception{
 //BA.debugLineNum = 164;BA.debugLine="Sub AST1_Terminated";
 //BA.debugLineNum = 165;BA.debugLine="Tconnected=False";
_tconnected = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 166;BA.debugLine="Log(destIP & \" - AST1-TCP Terminated\")";
anywheresoftware.b4a.keywords.Common.LogImpl("5720898",_destip+" - AST1-TCP Terminated",0);
 //BA.debugLineNum = 167;BA.debugLine="End Sub";
return "";
}
public static String  _ast2_error() throws Exception{
 //BA.debugLineNum = 107;BA.debugLine="Sub AST2_Error";
 //BA.debugLineNum = 108;BA.debugLine="Lconnected=False";
_lconnected = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 109;BA.debugLine="Log(\"Local Server Disconnect\")";
anywheresoftware.b4a.keywords.Common.LogImpl("5327682","Local Server Disconnect",0);
 //BA.debugLineNum = 110;BA.debugLine="End Sub";
return "";
}
public static String  _ast2_newdata(byte[] _buffer) throws Exception{
 //BA.debugLineNum = 117;BA.debugLine="Private Sub AST2_NewData (Buffer() As Byte)";
 //BA.debugLineNum = 121;BA.debugLine="mqtt.Publish2(mqtt_topic & \"fromserver\",Buffer,m";
_mqtt.Publish2(_mqtt_topic+"fromserver",_buffer,_mqtt_qos,anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 122;BA.debugLine="End Sub";
return "";
}
public static String  _ast2_terminated() throws Exception{
 //BA.debugLineNum = 112;BA.debugLine="Sub AST2_Terminated";
 //BA.debugLineNum = 113;BA.debugLine="Lconnected=False";
_lconnected = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 114;BA.debugLine="Log(\"Local Server Disconnect\")";
anywheresoftware.b4a.keywords.Common.LogImpl("5393218","Local Server Disconnect",0);
 //BA.debugLineNum = 115;BA.debugLine="End Sub";
return "";
}
public static String  _closeexistingconnection() throws Exception{
 //BA.debugLineNum = 148;BA.debugLine="Sub CloseExistingConnection";
 //BA.debugLineNum = 149;BA.debugLine="If AST1.IsInitialized Then AST1.Close";
if (_ast1.IsInitialized()) { 
_ast1.Close();};
 //BA.debugLineNum = 150;BA.debugLine="If client.IsInitialized Then client.Close";
if (_client.IsInitialized()) { 
_client.Close();};
 //BA.debugLineNum = 151;BA.debugLine="Tconnected=False";
_tconnected = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 152;BA.debugLine="Log(destIP & \" - Connection Closed\")";
anywheresoftware.b4a.keywords.Common.LogImpl("5589828",_destip+" - Connection Closed",0);
 //BA.debugLineNum = 153;BA.debugLine="End Sub";
return "";
}
public static String  _closeexistingserverconnection() throws Exception{
 //BA.debugLineNum = 101;BA.debugLine="Sub CloseExistingServerConnection";
 //BA.debugLineNum = 102;BA.debugLine="If AST2.IsInitialized Then AST2.Close";
if (_ast2.IsInitialized()) { 
_ast2.Close();};
 //BA.debugLineNum = 103;BA.debugLine="If Lclient.IsInitialized Then Lclient.Close";
if (_lclient.IsInitialized()) { 
_lclient.Close();};
 //BA.debugLineNum = 104;BA.debugLine="Lconnected=False";
_lconnected = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 105;BA.debugLine="End Sub";
return "";
}
public static void  _connecttomqttserver() throws Exception{
ResumableSub_ConnectToMQTTServer rsub = new ResumableSub_ConnectToMQTTServer(null);
rsub.resume(ba, null);
}
public static class ResumableSub_ConnectToMQTTServer extends BA.ResumableSub {
public ResumableSub_ConnectToMQTTServer(mqtt.proxy.main parent) {
this.parent = parent;
}
mqtt.proxy.main parent;
anywheresoftware.b4j.objects.MqttAsyncClientWrapper.MqttConnectOptionsWrapper _mo = null;
boolean _success = false;

@Override
public void resume(BA ba, Object[] result) throws Exception{

    while (true) {
        switch (state) {
            case -1:
return;

case 0:
//C
this.state = 1;
 //BA.debugLineNum = 182;BA.debugLine="Do While working";
if (true) break;

case 1:
//do while
this.state = 24;
while (parent._working) {
this.state = 3;
if (true) break;
}
if (true) break;

case 3:
//C
this.state = 4;
 //BA.debugLineNum = 183;BA.debugLine="If mqtt.IsInitialized Then mqtt.Close";
if (true) break;

case 4:
//if
this.state = 9;
if (parent._mqtt.IsInitialized()) { 
this.state = 6;
;}if (true) break;

case 6:
//C
this.state = 9;
parent._mqtt.Close();
if (true) break;

case 9:
//C
this.state = 10;
;
 //BA.debugLineNum = 184;BA.debugLine="Do While mqtt.IsInitialized";
if (true) break;

case 10:
//do while
this.state = 13;
while (parent._mqtt.IsInitialized()) {
this.state = 12;
if (true) break;
}
if (true) break;

case 12:
//C
this.state = 10;
 //BA.debugLineNum = 185;BA.debugLine="Sleep(100)";
anywheresoftware.b4a.keywords.Common.Sleep(ba,this,(int) (100));
this.state = 25;
return;
case 25:
//C
this.state = 10;
;
 if (true) break;

case 13:
//C
this.state = 14;
;
 //BA.debugLineNum = 187;BA.debugLine="mqtt.Initialize(\"mqtt\",  \"tcp://\" & mqtt_server,";
parent._mqtt.Initialize(ba,"mqtt","tcp://"+parent._mqtt_server,parent._mqtt_clientid);
 //BA.debugLineNum = 188;BA.debugLine="Private mo As MqttConnectOptions";
_mo = new anywheresoftware.b4j.objects.MqttAsyncClientWrapper.MqttConnectOptionsWrapper();
 //BA.debugLineNum = 189;BA.debugLine="mo.Initialize(mqtt_user, mqtt_password)";
_mo.Initialize(parent._mqtt_user,parent._mqtt_password);
 //BA.debugLineNum = 190;BA.debugLine="Log(\"Connecting to MQTT mqttserver: \" & mqtt_ser";
anywheresoftware.b4a.keywords.Common.LogImpl("5851977","Connecting to MQTT mqttserver: "+parent._mqtt_server,0);
 //BA.debugLineNum = 191;BA.debugLine="mqtt.Connect2(mo)";
parent._mqtt.Connect2((org.eclipse.paho.client.mqttv3.MqttConnectOptions)(_mo.getObject()));
 //BA.debugLineNum = 192;BA.debugLine="Wait For mqtt_Connected (Success As Boolean)";
anywheresoftware.b4a.keywords.Common.WaitFor("mqtt_connected", ba, this, null);
this.state = 26;
return;
case 26:
//C
this.state = 14;
_success = (boolean) result[0];
;
 //BA.debugLineNum = 193;BA.debugLine="If Success Then";
if (true) break;

case 14:
//if
this.state = 23;
if (_success) { 
this.state = 16;
}else {
this.state = 22;
}if (true) break;

case 16:
//C
this.state = 17;
 //BA.debugLineNum = 194;BA.debugLine="Log(\"Mqtt is connected\")";
anywheresoftware.b4a.keywords.Common.LogImpl("5851981","Mqtt is connected",0);
 //BA.debugLineNum = 195;BA.debugLine="mqtt.Subscribe(mqtt_topic & \"#\",0)";
parent._mqtt.Subscribe(parent._mqtt_topic+"#",(int) (0));
 //BA.debugLineNum = 196;BA.debugLine="Do While working And mqtt.Connected";
if (true) break;

case 17:
//do while
this.state = 20;
while (parent._working && parent._mqtt.getConnected()) {
this.state = 19;
if (true) break;
}
if (true) break;

case 19:
//C
this.state = 17;
 //BA.debugLineNum = 198;BA.debugLine="Sleep(5000)";
anywheresoftware.b4a.keywords.Common.Sleep(ba,this,(int) (5000));
this.state = 27;
return;
case 27:
//C
this.state = 17;
;
 if (true) break;

case 20:
//C
this.state = 23;
;
 //BA.debugLineNum = 200;BA.debugLine="Log(\"Mqtt is Disconnected\")";
anywheresoftware.b4a.keywords.Common.LogImpl("5851987","Mqtt is Disconnected",0);
 if (true) break;

case 22:
//C
this.state = 23;
 //BA.debugLineNum = 202;BA.debugLine="Log(\"Mqtt Error connecting.\")";
anywheresoftware.b4a.keywords.Common.LogImpl("5851989","Mqtt Error connecting.",0);
 if (true) break;

case 23:
//C
this.state = 1;
;
 //BA.debugLineNum = 204;BA.debugLine="Sleep(5000)";
anywheresoftware.b4a.keywords.Common.Sleep(ba,this,(int) (5000));
this.state = 28;
return;
case 28:
//C
this.state = 1;
;
 if (true) break;

case 24:
//C
this.state = -1;
;
 //BA.debugLineNum = 206;BA.debugLine="End Sub";
if (true) break;

            }
        }
    }
}
public static void  _connecttoserver() throws Exception{
ResumableSub_ConnectToServer rsub = new ResumableSub_ConnectToServer(null);
rsub.resume(ba, null);
}
public static class ResumableSub_ConnectToServer extends BA.ResumableSub {
public ResumableSub_ConnectToServer(mqtt.proxy.main parent) {
this.parent = parent;
}
mqtt.proxy.main parent;
boolean _successful = false;

@Override
public void resume(BA ba, Object[] result) throws Exception{

    while (true) {
        switch (state) {
            case -1:
return;

case 0:
//C
this.state = 1;
 //BA.debugLineNum = 128;BA.debugLine="Do While working";
if (true) break;

case 1:
//do while
this.state = 14;
while (parent._working) {
this.state = 3;
if (true) break;
}
if (true) break;

case 3:
//C
this.state = 4;
 //BA.debugLineNum = 129;BA.debugLine="CloseExistingConnection";
_closeexistingconnection();
 //BA.debugLineNum = 130;BA.debugLine="Log(\"Trying to connect to: \" & destIP)";
anywheresoftware.b4a.keywords.Common.LogImpl("5524291","Trying to connect to: "+parent._destip,0);
 //BA.debugLineNum = 131;BA.debugLine="client.Initialize(\"Client\")";
parent._client.Initialize("Client");
 //BA.debugLineNum = 132;BA.debugLine="client.Connect(destIP, destport, 10000)";
parent._client.Connect(ba,parent._destip,parent._destport,(int) (10000));
 //BA.debugLineNum = 133;BA.debugLine="Wait For Client_Connected (Successful As Boolean";
anywheresoftware.b4a.keywords.Common.WaitFor("client_connected", ba, this, null);
this.state = 15;
return;
case 15:
//C
this.state = 4;
_successful = (boolean) result[0];
;
 //BA.debugLineNum = 134;BA.debugLine="If Successful Then";
if (true) break;

case 4:
//if
this.state = 13;
if (_successful) { 
this.state = 6;
}else {
this.state = 12;
}if (true) break;

case 6:
//C
this.state = 7;
 //BA.debugLineNum = 135;BA.debugLine="Tconnected=True";
parent._tconnected = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 136;BA.debugLine="AST1.Initialize(client.InputStream, client.Outp";
parent._ast1.Initialize(ba,parent._client.getInputStream(),parent._client.getOutputStream(),"AST1");
 //BA.debugLineNum = 137;BA.debugLine="Log(\"Successful Connect to: \" & destIP & \":\" &";
anywheresoftware.b4a.keywords.Common.LogImpl("5524298","Successful Connect to: "+parent._destip+":"+BA.NumberToString(parent._destport),0);
 //BA.debugLineNum = 138;BA.debugLine="Do While working And Tconnected";
if (true) break;

case 7:
//do while
this.state = 10;
while (parent._working && parent._tconnected) {
this.state = 9;
if (true) break;
}
if (true) break;

case 9:
//C
this.state = 7;
 //BA.debugLineNum = 139;BA.debugLine="Sleep(5000)";
anywheresoftware.b4a.keywords.Common.Sleep(ba,this,(int) (5000));
this.state = 16;
return;
case 16:
//C
this.state = 7;
;
 if (true) break;

case 10:
//C
this.state = 13;
;
 if (true) break;

case 12:
//C
this.state = 13;
 //BA.debugLineNum = 142;BA.debugLine="Log(destIP & \" - Failed to connect \")";
anywheresoftware.b4a.keywords.Common.LogImpl("5524303",parent._destip+" - Failed to connect ",0);
 if (true) break;

case 13:
//C
this.state = 1;
;
 //BA.debugLineNum = 144;BA.debugLine="Sleep(5000)";
anywheresoftware.b4a.keywords.Common.Sleep(ba,this,(int) (5000));
this.state = 17;
return;
case 17:
//C
this.state = 1;
;
 if (true) break;

case 14:
//C
this.state = -1;
;
 //BA.debugLineNum = 146;BA.debugLine="End Sub";
if (true) break;

            }
        }
    }
}
public static void  _client_connected(boolean _successful) throws Exception{
}
public static void  _listenforconnections() throws Exception{
ResumableSub_ListenForConnections rsub = new ResumableSub_ListenForConnections(null);
rsub.resume(ba, null);
}
public static class ResumableSub_ListenForConnections extends BA.ResumableSub {
public ResumableSub_ListenForConnections(mqtt.proxy.main parent) {
this.parent = parent;
}
mqtt.proxy.main parent;
boolean _successful = false;
anywheresoftware.b4a.objects.SocketWrapper _newsocket = null;

@Override
public void resume(BA ba, Object[] result) throws Exception{

    while (true) {
        switch (state) {
            case -1:
return;

case 0:
//C
this.state = 1;
 //BA.debugLineNum = 85;BA.debugLine="Do While working";
if (true) break;

case 1:
//do while
this.state = 8;
while (parent._working) {
this.state = 3;
if (true) break;
}
if (true) break;

case 3:
//C
this.state = 4;
 //BA.debugLineNum = 86;BA.debugLine="server.Listen";
parent._server.Listen();
 //BA.debugLineNum = 87;BA.debugLine="Log(\"Local Server Listening on Port: \" & Lport)";
anywheresoftware.b4a.keywords.Common.LogImpl("5196611","Local Server Listening on Port: "+BA.NumberToString(parent._lport),0);
 //BA.debugLineNum = 88;BA.debugLine="Wait For Server_NewConnection (Successful As Boo";
anywheresoftware.b4a.keywords.Common.WaitFor("server_newconnection", ba, this, null);
this.state = 9;
return;
case 9:
//C
this.state = 4;
_successful = (boolean) result[0];
_newsocket = (anywheresoftware.b4a.objects.SocketWrapper) result[1];
;
 //BA.debugLineNum = 89;BA.debugLine="If Successful Then";
if (true) break;

case 4:
//if
this.state = 7;
if (_successful) { 
this.state = 6;
}if (true) break;

case 6:
//C
this.state = 7;
 //BA.debugLineNum = 90;BA.debugLine="CloseExistingServerConnection";
_closeexistingserverconnection();
 //BA.debugLineNum = 91;BA.debugLine="Lclient = NewSocket";
parent._lclient = _newsocket;
 //BA.debugLineNum = 92;BA.debugLine="AST2.Initialize(Lclient.InputStream,Lclient.Out";
parent._ast2.Initialize(ba,parent._lclient.getInputStream(),parent._lclient.getOutputStream(),"AST2");
 //BA.debugLineNum = 93;BA.debugLine="Lconnected=True";
parent._lconnected = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 95;BA.debugLine="mqtt.Publish2(mqtt_topic & \"ConnectToServer\", A";
parent._mqtt.Publish2(parent._mqtt_topic+"ConnectToServer",new byte[]{(byte) (0)},parent._mqtt_qos,anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 96;BA.debugLine="Log(\"Local Server Connected\")";
anywheresoftware.b4a.keywords.Common.LogImpl("5196620","Local Server Connected",0);
 if (true) break;

case 7:
//C
this.state = 1;
;
 if (true) break;

case 8:
//C
this.state = -1;
;
 //BA.debugLineNum = 99;BA.debugLine="End Sub";
if (true) break;

            }
        }
    }
}
public static void  _server_newconnection(boolean _successful,anywheresoftware.b4a.objects.SocketWrapper _newsocket) throws Exception{
}
public static String  _mqtt_connected(boolean _success) throws Exception{
 //BA.debugLineNum = 208;BA.debugLine="Private Sub mqtt_Connected (Success As Boolean)";
 //BA.debugLineNum = 210;BA.debugLine="End Sub";
return "";
}
public static String  _mqtt_disconnected() throws Exception{
 //BA.debugLineNum = 212;BA.debugLine="Private Sub mqtt_Disconnected";
 //BA.debugLineNum = 214;BA.debugLine="End Sub";
return "";
}
public static String  _mqtt_messagearrived(String _topic,byte[] _payload) throws Exception{
 //BA.debugLineNum = 216;BA.debugLine="Private Sub mqtt_MessageArrived (Topic As String,";
 //BA.debugLineNum = 218;BA.debugLine="If Topic.Contains(\"fromclient\") Then";
if (_topic.contains("fromclient")) { 
 //BA.debugLineNum = 219;BA.debugLine="AST2.Write(Payload)			'send it to the server";
_ast2.Write(_payload);
 };
 //BA.debugLineNum = 221;BA.debugLine="If Topic.Contains(\"fromserver\") Then";
if (_topic.contains("fromserver")) { 
 //BA.debugLineNum = 222;BA.debugLine="AST1.Write(Payload)			'send it to the client";
_ast1.Write(_payload);
 };
 //BA.debugLineNum = 224;BA.debugLine="If Topic.Contains(\"ConnectToServer\") Then";
if (_topic.contains("ConnectToServer")) { 
 //BA.debugLineNum = 225;BA.debugLine="If pmode=\"remote\" Then ConnectToServer";
if ((_pmode).equals("remote")) { 
_connecttoserver();};
 };
 //BA.debugLineNum = 228;BA.debugLine="End Sub";
return "";
}

private static boolean processGlobalsRun;
public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 17;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 18;BA.debugLine="Private AST1 As AsyncStreams										' TCP Clien";
_ast1 = new anywheresoftware.b4a.randomaccessfile.AsyncStreams();
 //BA.debugLineNum = 19;BA.debugLine="Private client As Socket											' Client Socke";
_client = new anywheresoftware.b4a.objects.SocketWrapper();
 //BA.debugLineNum = 20;BA.debugLine="Private destIP As String=\"192.168.1.147\"							'";
_destip = "192.168.1.147";
 //BA.debugLineNum = 21;BA.debugLine="Private destport As Int=22											' Destinatio";
_destport = (int) (22);
 //BA.debugLineNum = 22;BA.debugLine="Private Tconnected As Boolean=False									' TCP";
_tconnected = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 24;BA.debugLine="Private AST2 As AsyncStreams										' TCP Conne";
_ast2 = new anywheresoftware.b4a.randomaccessfile.AsyncStreams();
 //BA.debugLineNum = 25;BA.debugLine="Public server As ServerSocket										' TCP List";
_server = new anywheresoftware.b4a.objects.SocketWrapper.ServerSocketWrapper();
 //BA.debugLineNum = 26;BA.debugLine="Private Lport As Int=2222											' Listening S";
_lport = (int) (2222);
 //BA.debugLineNum = 27;BA.debugLine="Private Lclient As Socket											' Server's Cl";
_lclient = new anywheresoftware.b4a.objects.SocketWrapper();
 //BA.debugLineNum = 28;BA.debugLine="Private Lconnected As Boolean=False									' Lis";
_lconnected = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 31;BA.debugLine="Private mqtt As MqttClient";
_mqtt = new anywheresoftware.b4j.objects.MqttAsyncClientWrapper();
 //BA.debugLineNum = 32;BA.debugLine="Private mqtt_topic As String=\"mqttproxy/ABC/\"";
_mqtt_topic = "mqttproxy/ABC/";
 //BA.debugLineNum = 33;BA.debugLine="Private mqtt_user As String = \"dn2k\"								' mqt";
_mqtt_user = "dn2k";
 //BA.debugLineNum = 34;BA.debugLine="Private mqtt_password As String = \"denver5\"";
_mqtt_password = "denver5";
 //BA.debugLineNum = 35;BA.debugLine="Private mqtt_server As String = \"mqtt.weatheracti";
_mqtt_server = "mqtt.weatheractive.org:1883";
 //BA.debugLineNum = 36;BA.debugLine="Private mqtt_clientID As String										' client";
_mqtt_clientid = "";
 //BA.debugLineNum = 37;BA.debugLine="Private mqtt_qos As Int=0											' QOS=0 is be";
_mqtt_qos = (int) (0);
 //BA.debugLineNum = 39;BA.debugLine="Private working As Boolean = False";
_working = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 40;BA.debugLine="Private pmode As String = \"local\"									'Progra";
_pmode = "local";
 //BA.debugLineNum = 42;BA.debugLine="End Sub";
return "";
}
public static String  _readcfgfile() throws Exception{
anywheresoftware.b4a.objects.collections.Map _config = null;
 //BA.debugLineNum = 62;BA.debugLine="Sub ReadCFGFile";
 //BA.debugLineNum = 63;BA.debugLine="If File.Exists(File.DirApp , \"/mqttproxy.cfg\") Th";
if (anywheresoftware.b4a.keywords.Common.File.Exists(anywheresoftware.b4a.keywords.Common.File.getDirApp(),"/mqttproxy.cfg")) { 
 //BA.debugLineNum = 64;BA.debugLine="Dim config As Map = File.ReadMap(File.DirApp , \"";
_config = new anywheresoftware.b4a.objects.collections.Map();
_config = anywheresoftware.b4a.keywords.Common.File.ReadMap(anywheresoftware.b4a.keywords.Common.File.getDirApp(),"/mqttproxy.cfg");
 //BA.debugLineNum = 65;BA.debugLine="destIP 			= config.Get(\"dest_IP\")";
_destip = BA.ObjectToString(_config.Get((Object)("dest_IP")));
 //BA.debugLineNum = 66;BA.debugLine="destport 		= config.Get(\"dest_port\")";
_destport = (int)(BA.ObjectToNumber(_config.Get((Object)("dest_port"))));
 //BA.debugLineNum = 67;BA.debugLine="Lport 			= config.Get(\"local_port\")";
_lport = (int)(BA.ObjectToNumber(_config.Get((Object)("local_port"))));
 //BA.debugLineNum = 68;BA.debugLine="mqtt_server 	= config.Get(\"mqtt_server\")";
_mqtt_server = BA.ObjectToString(_config.Get((Object)("mqtt_server")));
 //BA.debugLineNum = 69;BA.debugLine="mqtt_user 		= config.Get(\"mqtt_username\")";
_mqtt_user = BA.ObjectToString(_config.Get((Object)("mqtt_username")));
 //BA.debugLineNum = 70;BA.debugLine="mqtt_password 	= config.Get(\"mqtt_password\")";
_mqtt_password = BA.ObjectToString(_config.Get((Object)("mqtt_password")));
 //BA.debugLineNum = 71;BA.debugLine="mqtt_topic 		= config.Get(\"mqtt_topic\")";
_mqtt_topic = BA.ObjectToString(_config.Get((Object)("mqtt_topic")));
 //BA.debugLineNum = 72;BA.debugLine="mqtt_qos		= config.Get(\"mqtt_qos\")";
_mqtt_qos = (int)(BA.ObjectToNumber(_config.Get((Object)("mqtt_qos"))));
 //BA.debugLineNum = 73;BA.debugLine="pmode	 		= config.Get(\"program_mode\")";
_pmode = BA.ObjectToString(_config.Get((Object)("program_mode")));
 }else {
 //BA.debugLineNum = 75;BA.debugLine="Log(\"**** mqttproxy.cfg does not exists - Applic";
anywheresoftware.b4a.keywords.Common.LogImpl("5131085","**** mqttproxy.cfg does not exists - Application Terminated ****",0);
 //BA.debugLineNum = 76;BA.debugLine="ExitApplication";
anywheresoftware.b4a.keywords.Common.ExitApplication();
 };
 //BA.debugLineNum = 78;BA.debugLine="End Sub";
return "";
}
}
